package com.demo.controller;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Contro extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doPost(req, resp);
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String body = null;

		String uri = req.getRequestURI();
		System.out.println(uri);
		// 云通讯IVR启动业务的回调请求，请求的url中固定相对地址startservice
		if (uri.contains("startservice")) {
			body = startservice(req);
		}
		// 云通讯呼转命令的回调请求，通知第三方用户的按键超时，请求URL中的相对地址gettimeout可以自定义，demo中自定义为gettimeout
		if (uri.contains("gettimeout")) {
			body = gettimeout(req);
		}
		// 云通讯按键命令的回调请求，通知第三方用户的按键信息，请求URL中的相对地址dtmfreport可以自定义，demo中自定义为dtmfreport
		if (uri.contains("dtmfreport")) {
			body = dtmfreport(req);
		}
		// 云通讯呼转命令的回调请求，通知第三方转接座席失败，请求URL中的相对地址transferAgentFail可以自定义，demo中自定义为transferAgentFail
		if (uri.contains("transferAgentFail")) {
			body = transferAgentFail(req);
		}
		// 云通讯按键命令的回调请求，通知第三方用户的按键超时，请求URL中的相对地址getchinesequeue可以自定义，demo中自定义为getchinesequeue
		if (uri.contains("getchinesequeue")) {
			body = getchinesequeue(req);
		}
		// 云通讯按键命令的回调请求，通知第三方用户的按键超时，请求URL中的相对地址getenglishqueue可以自定义，demo中自定义为getenglishqueue
		if (uri.contains("getenglishqueue")) {
			body = getenglishqueue(req);
		}
		// 云通讯座席挂机的回调请求，通知第三方座席挂机，请求URL中的相对地址agenthangup可以自定义，demo中自定义为agenthangup
		if (uri.contains("agenthangup")) {
			body = agenthangup(req);
		}
		// 云通讯按键命令的回调请求，通知第三方用户的按键信息，请求URL中的相对地址pingjia可以自定义，demo中自定义为pingjia
		if (uri.contains("pingjia")) {
			body = pingjia(req);
		}
		// 云通讯座席状态变化的回调请求，通知第三方座席挂机，请求的url中固定相对地址agentstate
		if (uri.contains("agentstate")) {
			body = agentstate(req);
		}
		// 云通讯IVR结束业务的回调请求，请求的url中固定相对地址stopservice
		if (uri.contains("stopservice")) {
			body = stopservice(req);
		}
		PrintWriter out = resp.getWriter();
		out.println(body);
	}

	// IVR启动业务，在IVR呼入或者IVR外呼后由云通讯平台发起的回调请求
	public String startservice(HttpServletRequest req) {
		// // 打印URL中的参数
		// Map map = req.getParameterMap();
		// Set<String> keySet = map.keySet();
		// for (String key : keySet) {
		// String[] values = (String[]) map.get(key);
		// for (String value : values) {
		// System.out.println(key + "=" + value);
		// }
		// }
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String from = req.getParameter("from");//主叫号码，当IVR呼入方式为主叫的号码，当IVR外呼的方式则为空
		String to = req.getParameter("to");//被叫号码，当IVR呼入方式为IVR接入号，当IVR外呼的方式则为外呼的号码
		String direction = req.getParameter("direction");//呼叫方式，IVR呼入为0，IVR外呼为1
	    //$userdata = $_REQUEST['userdata'];	//自定义参数，只有发起当外呼请求中带有才会返回，可以通过该参数和callid绑定来确定发起的请求
	    //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后跳转到gettimeout
	    //命令中action='dtmfreport'为自定义按键回调相对地址
	    //numdigits='1'定义按键个数为1，当用户按任意一个键就会通知第三方服务器
	    //timeout='20'为用户按键超时时间20秒，当放音第一次完成后开始计时，用户20秒没有按键就会执行副命令
	    //loop='-1'为循环放音，当超时后停止放音
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='dtmfreport' numdigits='1' timeout='20'><Play loop='-1'>menu.wav</Play></Get><Play>timeout.wav</Play><Redirect>gettimeout</Redirect></Response>";
		return result;
	}

	//用户按键超时
	public String gettimeout(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
	    //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后挂断用户
		String result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>timeoutbye.wav</Play><Hangup/></Response>";

		return result;
	}
	
	// 用户按键
	public String dtmfreport(HttpServletRequest req) {
		// 获取URL中的参数
		String result="";
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");//用户按键内容
	    //对云通讯平台回调请求的响应包体
		if (digits.equals("1")) {
	    	//当用户按1键后响应进入1队列排队等待坐席接听，如果超时没有坐席接听或者呼叫坐席失败跳转到transferAgentFail
	    	//queuetype='1'表示用户进入1队列，由1队列中的坐席服务，如果该队列没有创建则会挂机
	    	//timeout='30'表示用户进入队列没有坐席服务的时候用户排队等待超时时间为30秒
	    	//queuetimes='1'表示用户排队等待超时的次数为1次
	    	//agenthangupurl='agenthangup'为坐席挂机后回调的相对地址，可以自定义
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><EnterCCS queuetype='1' timeout='30' queuetimes='1' agenthangupurl='agenthangup'><Play loop='-1'>waitmusic.wav</Play></EnterCCS><Redirect tag='1'>transferAgentFail</Redirect></Response>";
		}else if (digits.equals("2")) {
	    	//当用户按2键后响应进入2队列排队等待坐席接听，如果超时没有坐席接听或者呼叫坐席失败跳转到transferAgentFail
	    	//queuetype='2'表示用户进入2队列，由2队列中的坐席服务，如果该队列没有创建则会挂机
	    	//timeout='30'表示用户进入队列没有坐席服务的时候用户排队等待超时时间为30秒
	    	//queuetimes='1'表示用户排队等待超时的次数为1次
	    	//agenthangupurl='agenthangup'为坐席挂机后回调的相对地址，可以自定义
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><EnterCCS queuetype='2' timeout='30' queuetimes='1' agenthangupurl='agenthangup'><Play loop='-1'>waitmusic.wav</Play></EnterCCS><Redirect tag='2'>transferAgentFail</Redirect></Response>";
		}else{
	    	//当用户按1和2之外的其他键则放音提示后直接挂机
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>bye.wav</Play><Hangup/></Response>";
		}


		return result;
	}
	//转接坐席失败
	public String transferAgentFail(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String tag = req.getParameter("tag");//指定的标识值
		String result = "";
		//对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后挂断用户
		if (tag.equals("1")) {
			//当进入1队列呼叫坐席呼叫后提供用户继续排队按键，当按键超时后放音提示用户，放音完成后挂机
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Get action='getchinesequeue' numdigits='1' timeout='20'><Play loop='-1'>buzy.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup/></Response>";
		}else if (tag.equals("2")) {
			//当进入2队列呼叫坐席呼叫后提供用户继续排队按键，当按键超时后放音提示用户，放音完成后挂机
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Get action='getenglishqueue' numdigits='1' timeout='20'><Play loop='-1'>buzy.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup/></Response>";
		}else{
			//逻辑保护用
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>bye.wav</Play><Hangup/></Response>";
		}
		return result;
	}
	//转接坐席失败用户按键继续进入中文队列
	public String getchinesequeue(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");//用户按键内容
		String result = "";
		//对云通讯平台回调请求的响应包体
		if (digits.equals("1")) {
			//用户按键1继续进入1队列等待坐席服务
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><EnterCCS queuetype='1' timeout='30' queuetimes='1' agenthangupurl='agenthangup'><Play>waitmusic.wav</Play></EnterCCS><Redirect tag='1'>transferAgentFail</Redirect></Response>";
		}else{
			//用户按1之外的其他键放音提示后挂机
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>bye.wav</Play><Hangup/></Response>";
		}

		return result;
	}
	//转接坐席失败用户按键继续进入英文队列
	public String getenglishqueue(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");//用户按键内容
		String result = "";
	    //对云通讯平台回调请求的响应包体
		if (digits.equals("1")) {
			//用户按键1继续进入2队列等待坐席服务
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><EnterCCS queuetype='2' timeout='30' queuetimes='1' agenthangupurl='agenthangup'><Play>waitmusic.wav</Play></EnterCCS><Redirect tag='2'>transferAgentFail</Redirect></Response>";
		}else{
			//用户按1之外的其他键放音提示后挂机
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>bye.wav</Play><Hangup/></Response>";
		}

		return result;
	}
	//坐席挂机
	public String agenthangup(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String agentid = req.getParameter("agentid");//与其通话的座席id。
		String duration = req.getParameter("duration");//用户与座席通话时长,单位是秒。
		String endtype = req.getParameter("endtype");//通话结束类型：0座席结束通话、1座席挂机、2强拆结束、3用户挂机。
		String recordurl = req.getParameter("recordurl");//录音下载地址。
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
	    //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后挂断用户
		String result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Get action='pingjia' numdigits='1' timeout='20'><Play loop='-1'>pingjia.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup/></Response>";

		return result;
	}
	
	//用户评价
	public String pingjia(HttpServletRequest req) {
		// 获取URL中的参数
		String result="";
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");//用户按键内容
		//对云通讯平台回调请求的响应包体
		if (digits.equals("1")) {
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>thank.wav</Play><Hangup/></Response>";
		}else if (digits.equals("2")) {
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>thank.wav</Play><Hangup/></Response>";
		}else{
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Play>timeoutbye.wav</Play>Hangup/></Response>";
		}


		return result;
	}
	//坐席状态改变通知
	public String agentstate(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String agentid = req.getParameter("agentid");//坐席id，与用户通话的坐席
		String agentstate = req.getParameter("agentstate");//坐席的状态：0准备中、1准备就绪、2锁定中、3通话中、4线路忙
		String number = req.getParameter("number");//用户的号码，当agentstate为2或3有效
		String time = req.getParameter("time");//坐席状态切换时间
		String queuetype = req.getParameter("queuetype");//用户进入队列类型，当agentstate为2或3有效
		String alertingtime = req.getParameter("alertingtime");//坐席振铃时间，当agentstate为3有效。
		String isqueue = req.getParameter("isqueue");//录音下载地址。
		//对云通讯平台回调请求的响应包体，因为不需要后续流程响应空命令
		String result = "<?xml version='1.0' encoding='UTF-8' ?><Response><CmdNone/></Response>";

		return result;
	}
	/* 
	//坐席状态改变通知，用来自动准备就绪
	public String agentstate(HttpServletRequest req) {
		String result="";
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String agentid = req.getParameter("agentid");//坐席id，与用户通话的坐席
		String agentstate = req.getParameter("agentstate");//坐席的状态：0准备中、1准备就绪、2锁定中、3通话中、4线路忙
		String number = req.getParameter("number");//用户的号码，当agentstate为2或3有效
		String time = req.getParameter("time");//坐席状态切换时间
		String queuetype = req.getParameter("queuetype");//用户进入队列类型，当agentstate为2或3有效
		String alertingtime = req.getParameter("alertingtime");//坐席振铃时间，当agentstate为3有效。
		String isqueue = req.getParameter("isqueue");//录音下载地址。
		//对云通讯平台回调请求的响应包体
		if(agentstate.equals("0")){
		//响应的为坐席准备就绪命令，当坐席状态改变为0准备中的时候响应坐席准备就绪
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><Appid>"+appid+"</Appid><AgentReady agentid='"+agentid+"'/></Response>";
		}else{
			//响应空命令，其他坐席状态不需要后续命令
			result = "<?xml version='1.0' encoding='UTF-8' ?><Response><CmdNone/></Response>";
		}

		return result;
	}*/
	
	//IVR结束业务，在用户挂机后由云通讯平台发起的回调请求
	public String stopservice(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");//应用id
		String callid = req.getParameter("callid");//通话id，由云通讯平台产生的一路通话的唯一标识
		String starttime = req.getParameter("starttime");//主叫通话的开始时间
		String endtime = req.getParameter("endtime");//主叫通话的结束时间
		String callduration = req.getParameter("callduration");//主叫通话时长
		String sstime = req.getParameter("sstime");//被叫通话的开始时间
		String setime = req.getParameter("setime");//被叫通话的结束时间
		String seccallduration = req.getParameter("seccallduration");//被叫通话时间
		String recordurl = req.getParameter("recordurl");//录音文件下载地址
		String recordid = req.getParameter("recordid");//录音文件Id
		String errorcode = req.getParameter("errorcode");//通话中异常的错误值，可以根据错误知道出现异常的原因
		//对云通讯平台回调请求的响应包体，因为不需要后续流程响应空命令
		String result = "<?xml version='1.0' encoding='UTF-8' ?><Response><CmdNone/></Response>";
		return result;
	}

}
